function [J,Jmin] = ModelOrder(lambda,n) ; 

%lambda = sort(lambda(:),'descend')' ;
lambda = sort(lambda(:),'ascend')' ;
M = length(lambda) ;
alpha = M ; 
MM = [1:1:M] ; 

marr = cumsum(lambda)./MM ;  
mgeo = exp(cumsum(log(lambda))./MM) ;

J0 = -n*(alpha-MM).*log(mgeo./marr) ; 

P1 = MM.*(2*alpha-MM) ;                             
P2 = 0.5*MM*log(n).*(2*alpha-MM) ; 
P3 = 0.5*MM*sqrt(n.*log(log(n))).*(2*alpha-MM) ; 

J(1,:) = J0+P1 ; % AIC
J(2,:) = J0+P2 ; % MDL
J(3,:) = J0+P3 ; % EDC
J(4,:) = lambda-mean(lambda); % KG-EV1


% % Rao2007
% m=n; n=alpha;
% for k=1:M
%     %tk(k)=((n-k)*sum(lambda(k+1:end).^2)/sum(lambda(k+1:end))-(1+n/m))*n-n/M;
%     tk(k)=((n-k)*sum(lambda(1:k).^2)/sum(lambda(1:k))-(1+n/m))*n-n/M;
% end
% J(5,:) = 1/4*(m/n)^2*tk.^2+2*(k+1);
    

for k=1:size(J,1)
    %[tmp,Jmin(k)]=min(J(k,:));
    [tmp,itmp]=max(J(k,:)); Jmin(k)=M-itmp+1;
end
Jmin(4)=1.0*sum(lambda>mean(lambda));

%keyboard